observation:

  mode:  custom
  from_file:        'data/densities.txt'
  column_range:     [0, 5]
  parameters:
    - key:      pipeline.charge_transfer.cdm.arguments.beta
      values:   _
      enabled: true
    - key:      pipeline.charge_transfer.cdm.arguments.trap_densities
      values:   [_,_,_,_]
      enabled: true

  outputs:
    output_folder:  'outputs'
    save_data_to_file:
      - detector.image.array:   ['fits']

ccd_detector:

  geometry:

    row: 100              # pixel
    col: 100              # pixel
    total_thickness: 40.    # um
    pixel_vert_size: 10.    # um
    pixel_horz_size: 10.    # um

  environment:
    temperature: 300        # K

  characteristics:
    quantum_efficiency: 1.                   # -
    charge_to_volt_conversion: 3.e-6         # V/e
    pre_amplification: 100                  # V/V
    adc_voltage_range: [0., 10.]
    adc_bit_resolution: 16
    full_well_capacity: 100000                 # e

pipeline:
  # -> photon
  photon_generation:
    - name: load_image
      func: pyxel.models.photon_generation.load_image
      enabled: true
      arguments:
        image_file: 'data/inputs/image_non_irradiated.fits'
        convert_to_photons: true
        bit_resolution: 16

    - name: shot_noise
      func: pyxel.models.photon_generation.shot_noise
      enabled: false

  # photon -> photon
  optics:

  # photon -> charge
  charge_generation:
    - name: photoelectrons
      func: pyxel.models.charge_generation.simple_conversion
      enabled: true

  # charge -> pixel
  charge_collection:
    - name: simple_collection
      func: pyxel.models.charge_collection.simple_collection
      enabled: true

  # pixel -> pixel
  charge_transfer:
    - name: cdm
      func: pyxel.models.charge_transfer.cdm
      enabled: true
      arguments:
        direction: parallel
        trap_release_times: [3.e-2, 1.e-2, 30.e-2, 5.e-2]
        trap_densities: [20., 5., 30., 15.]
        sigma: [1.e-10, 1.e-10, 1.e-10, 1.e-10]
        beta: 0.3
        max_electron_volume: 1.62e-10   # cm^2
        transfer_period: 9.4722e-04     # s
        charge_injection: false


  # pixel -> signal
  charge_measurement:
    - name: simple_measurement
      func: pyxel.models.charge_measurement.simple_measurement
      enabled: true

  # signal -> image
  readout_electronics:
    - name: simple_amplifier
      func: pyxel.models.readout_electronics.simple_amplifier
      enabled: true
    - name: simple_adc
      func: pyxel.models.readout_electronics.simple_adc
      enabled: true


